#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "ranktable.h"
#include "getline.h"
#include "compress.h"

int
main(int argc, char **argv)
{
    Table t;
    char *line;
    unsigned long rank;
    unsigned long size;

    t = EMPTY_TABLE;

    while((line = getline('\n')) != 0) {
        rank = table_rank(t, line);

        if(rank == TABLE_NOT_FOUND) {
            /* write line */
            putchar(RAW_STRING_START);
            fputs(line, stdout);
            putchar(RAW_STRING_END);

            /* add it to the table */
            t = table_insert(t, line);
        } else {
            size = table_size(t);

            assert(size <= MAXSIZE_4);
            if(size > MAXSIZE_3) putchar(GET_BYTE(rank, 3));
            if(size > MAXSIZE_2) putchar(GET_BYTE(rank, 2));
            if(size > MAXSIZE_1) putchar(GET_BYTE(rank, 1));
            putchar(GET_BYTE(rank, 0));
        }

        free(line);
    }

    table_destroy(t);

    return 0;
}
