#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "ranktable.h"
#include "getline.h"
#include "compress.h"

int
main(int argc, char **argv)
{
    Table t;
    unsigned long rank;
    char *line;
    unsigned long size;

    t = EMPTY_TABLE;

    while((rank = getchar()) != EOF) {
        if(rank == RAW_STRING_START) {
            line = getline(RAW_STRING_END);

            /* write it out */
            puts(line);

            /* add it to the table */
            t = table_insert(t, line);

            free(line);
        } else {
            size = table_size(t);
            assert(size <= MAXSIZE_4);

            if(size > MAXSIZE_1) rank = (rank << BITS_PER_BYTE) + getchar();
            if(size > MAXSIZE_2) rank = (rank << BITS_PER_BYTE) + getchar();
            if(size > MAXSIZE_3) rank = (rank << BITS_PER_BYTE) + getchar();

            assert(rank < size);

            puts(table_find_by_rank(t, rank));
        }
    }

    table_destroy(t);

    return 0;
}
