#include <stdio.h>
#include <stdlib.h>

#include "getline.h"

char *
getline(int delimiter)
{
    char *line;		/* line buffer */
    int n;		/* characters read */
    int size; 		/* size of line buffer */
    int c;

    size = 1;
    line = malloc(size);
    if(line == 0) return 0;
    
    n = 0;

    while((c = getchar()) != delimiter && c != EOF) {
	while(n >= size - 1) {
	    size *= 2;
	    line = realloc(line, size);
	    if(line == 0) return 0;
	}
	line[n++] = c;
    }

    if(c == EOF && n == 0) {
	/* got nothing */
	free(line);
	return 0;
    } else {
	line[n++] = '\0';
	return line;
    }
}

