typedef struct table_node *Table;

#define EMPTY_TABLE (0)

#define TABLE_NOT_FOUND (0xfffffffful)

/* returns rank of key in t, or TABLE_NOT_FOUND if not present */
unsigned long table_rank(Table t, const char *key);

/* add a new key to a Table */
/* and return the new Table */
Table table_insert(Table t, const char *key);

/* return the total number of entries in the table */
unsigned long table_size(Table t);

/* return a key based its rank */
/* if called with too high a rank, returns 0 */
/* the returned data will last until the table is destroyed */
const char *table_find_by_rank(Table t, unsigned long rank);

/* free a Table */
void table_destroy(Table);
